#pragma once
#include "uart/ProtocolSender.h"
/*
*此文件由GUI工具生成
*文件功能：用于处理用户的逻辑相应代码
*功能说明：
*========================onButtonClick_XXXX
当页面中的按键按下后系统会调用对应的函数，XXX代表GUI工具里面的[ID值]名称，
如Button1,当返回值为false的时候系统将不再处理这个按键，返回true的时候系统将会继续处理此按键。比如SYS_BACK.
*========================onSlideWindowItemClick_XXXX(int index) 
当页面中存在滑动窗口并且用户点击了滑动窗口的图标后系统会调用此函数,XXX代表GUI工具里面的[ID值]名称，
如slideWindow1;index 代表按下图标的偏移值
*========================onSeekBarChange_XXXX(int progress) 
当页面中存在滑动条并且用户改变了进度后系统会调用此函数,XXX代表GUI工具里面的[ID值]名称，
如SeekBar1;progress 代表当前的进度值
*========================ogetListItemCount_XXXX() 
当页面中存在滑动列表的时候，更新的时候系统会调用此接口获取列表的总数目,XXX代表GUI工具里面的[ID值]名称，
如List1;返回值为当前列表的总条数
*========================oobtainListItemData_XXXX(ZKListView::ZKListItem *pListItem, int index)
 当页面中存在滑动列表的时候，更新的时候系统会调用此接口获取列表当前条目下的内容信息,XXX代表GUI工具里面的[ID值]名称，
如List1;pListItem 是贴图中的单条目对象，index是列表总目的偏移量。具体见函数说明
*========================常用接口===============
*LOGD(...)  打印调试信息的接口
*mTextXXXPtr->setText("****") 在控件TextXXX上显示文字****
*mButton1Ptr->setSelected(true); 将控件mButton1设置为选中模式，图片会切换成选中图片，按钮文字会切换为选中后的颜色
*mSeekBarPtr->setProgress(12) 在控件mSeekBar上将进度调整到12
*mListView1Ptr->refreshListView() 让mListView1 重新刷新，当列表数据变化后调用
*mDashbroadView1Ptr->setTargetAngle(120) 在控件mDashbroadView1上指针显示角度调整到120度
*
* 在Eclipse编辑器中  使用 “alt + /”  快捷键可以打开智能提示
*/
#include "uart/ProtocolParser.h"
static SProtocolData mProtocolData;

/**
 * 注册定时器
 * 填充数组用于注册定时器
 * 注意：id不能重复
 */
static S_ACTIVITY_TIMEER REGISTER_ACTIVITY_TIMER_TAB[] = {
	//{0,  6000}, //定时器id=0, 时间间隔6秒
	//{1,  1000},
};

/**
 * 当界面构造时触发
 */
static void onUI_init(){
    //Tips :添加 UI初始化的显示代码到这里,如:mText1Ptr->setText("123");
	mProtocolData = getProtocolData();

}

/**
 * 当切换到该界面时触发
 */
static void onUI_intent(const Intent *intentPtr) {
    if (intentPtr != NULL) {
        //TODO
    }
}

/*
 * 当界面显示时触发
 */
static void onUI_show() {

}

/*
 * 当界面隐藏时触发
 */
static void onUI_hide() {

}

/*
 * 当界面完全退出时触发
 */
static void onUI_quit() {

}

static bool seteditText19flag = 0;
static bool seteditTextFloatflag = 0;
/**
 * 串口数据回调接口
 */
static void onProtocolDataUpdate(const SProtocolData &data) {
	if(mProtocolData.coils[4] != data.coils[0x04]){
		mProtocolData.coils[4] = data.coils[0x04];
		//通过数值设置背景色，可以修改为设置背景图或者修改显示内容
		if(data.coils[0x04]){
			mTextViewBitsPtr->setBackgroundColor(0xff000000);
			mTextViewBitsPtr->setText(1);
		}else{
			mTextViewBitsPtr->setBackgroundColor(0x00ff0000);
			mTextViewBitsPtr->setText(0);
		}
	}
	//当键盘关闭的时候
	if(!EASYUICONTEXT->isIMEShow() && (mProtocolData.regdata[19] != data.regdata[19])){
		mProtocolData.regdata[19] = data.regdata[19];
		seteditText19flag = 1; //设置主动显示的标记，解决编辑框再次写入到modbus中
		//int 整型可以直接显示
		mEditTextaddr19Ptr->setText(data.regdata[19]);
		LOGD("edit settext%d",data.regdata[19]);
	}

	if(!EASYUICONTEXT->isIMEShow() &&
			((mProtocolData.regdata[22] != data.regdata[22]) ||
			(mProtocolData.regdata[23] != data.regdata[23]))){

		mProtocolData.regdata[22] = data.regdata[22];
		mProtocolData.regdata[23] = data.regdata[23];

		int da = (data.regdata[22]<<16)|data.regdata[23];
		float fd = *(float*)&da;
		char str[64];
		//浮点需要格式化,然后再调用settext接口显示内容
		sprintf(str,"%.2f",fd);
		seteditTextFloatflag = 1;//设置主动显示的标记，解决编辑框再次写入到modbus中
		mEditTextFloatPtr->setText(str);
	}
}

/**
 * 定时器触发函数
 * 不建议在此函数中写耗时操作，否则将影响UI刷新
 * 参数： id
 *         当前所触发定时器的id，与注册时的id相同
 * 返回值: true
 *             继续运行当前定时器
 *         false
 *             停止运行当前定时器
 */
static bool onUI_Timer(int id){
	switch (id) {

		default:
			break;
	}
    return true;
}

/**
 * 有新的触摸事件时触发
 * 参数：ev
 *         新的触摸事件
 * 返回值：true
 *            表示该触摸事件在此被拦截，系统不再将此触摸事件传递到控件上
 *         false
 *            触摸事件将继续传递到控件上
 */
static bool onmainActivityTouchEvent(const MotionEvent &ev) {
    switch (ev.mActionStatus) {
		case MotionEvent::E_ACTION_DOWN://触摸按下
			//LOGD("时刻 = %ld 坐标  x = %d, y = %d", ev.mEventTime, ev.mX, ev.mY);
			break;
		case MotionEvent::E_ACTION_MOVE://触摸滑动
			break;
		case MotionEvent::E_ACTION_UP:  //触摸抬起
			break;
		default:
			break;
	}
	return false;
}
static void onEditTextChanged_EditTextaddr19(const std::string &text) {
	uint32_t data;
    if(seteditText19flag){
    	seteditText19flag = 0;
    	return;
    }
    LOGD(" onEditTextChanged_ EditTextaddr19 %s !!!\n", text.c_str());
	data = atoi(text.c_str());

	if((data >= 0 )&& (data <= 65535)){
		MODBUSCONTEXT->writeRegister(19,data);
		mProtocolData.regdata[19] = data;
	}else{
		LOGD("data out of rang");
		mEditTextaddr19Ptr->setText(0);
	}
}
static bool onButtonClick_Buttonwrite(ZKButton *pButton) {
    LOGD(" ButtonClick Buttonwrite !!!\n");

    MODBUSCONTEXT->setAddress(2);
    /*
    if(!pButton->isSelected()){
    	pButton->setSelected(true);
    	MODBUSCONTEXT->writeCoil(15, 1);
    }else{
    	pButton->setSelected(false);
    	MODBUSCONTEXT->writeCoil(15, 0);
    }*/
    int da = 345;
    float fd = *(float*)&da;
    return false;
}
static void onEditTextChanged_EditTextFloat(const std::string &text) {
    LOGD(" onEditTextChanged_ EditTextFloat %s !!!\n", text.c_str());
    if(seteditTextFloatflag){
    	seteditTextFloatflag = 0;
    	return;
    }
    float fdata;
    fdata = atof(text.c_str());
    uint32_t idata = *(unsigned int*)&fdata;
    uint16_t sendout16d[2];
    sendout16d[0] = (idata&0xffff0000) >> 16;
    sendout16d[1] = idata&0xffff;
    MODBUSCONTEXT->writeRegisters(22,sendout16d,2);
}
