/*
 * ModbusContext.h
 *
 *  Created on: 2019-10-9
 *      Author: zhonggp
 */

#ifndef _UART_MODBUSCONTEXT_H_
#define _UART_MODBUSCONTEXT_H_

#include <vector>
#include "system/Thread.h"
#include "CommDef.h"

class ModbusContext : public Thread {
public:
	virtual ~ModbusContext();

	bool openUart(const char *pFileName, UINT baudRate);
	void closeUart();

	bool isOpen() { return mIsOpen; }

	bool send(const BYTE *pData, UINT len);
	bool writeRegister(uint16_t addr,uint16_t data);
	bool writeCoil(uint16_t addr,BYTE data);
	bool writeRegisters(uint16_t addr,uint16_t* data,BYTE len);
	bool setAddress(uint8_t addr);

	static ModbusContext* getInstance();

protected:
	virtual bool readyToRun();
	virtual bool threadLoop();

private:
	 ModbusContext();
	 void processSendCmd();

private:
	bool mIsOpen;
	int mUartID;

	// 用于拼接缓存数据，可能存在上一包数据解析未完全，残留有数据
	BYTE *mDataBufPtr;
	int mDataBufLen;
};

#define MODBUSCONTEXT		ModbusContext::getInstance()

#endif /* _UART_MODBUSCONTEXT_H_ */
